diff --git a/web/pgadmin/tools/debugger/static/js/debugger_utils.js b/web/pgadmin/tools/debugger/static/js/debugger_utils.js
index fbc2f4b7..158ffbf4 100644
--- a/web/pgadmin/tools/debugger/static/js/debugger_utils.js
+++ b/web/pgadmin/tools/debugger/static/js/debugger_utils.js
@@ -9,17 +9,6 @@
 import {generateTitle} from '../../../sqleditor/static/js/sqleditor_title';
 import {_set_dynamic_tab} from '../../../sqleditor/static/js/show_query_tool';
 
-function setFocusToDebuggerEditor(editor, command) {
-  const TAB = 9;
-  if (!command)
-    return;
-  let key = command.which || command.keyCode;
-  // Keys other than Tab key
-  if (key !== TAB) {
-    editor.focus();
-  }
-}
-
 function getFunctionId(treeInfoObject) {
   let objectId;
   if(treeInfoObject) {
@@ -99,7 +88,6 @@ function getAppropriateLabel(treeInfo) {
 }
 
 module.exports = {
-  setFocusToDebuggerEditor: setFocusToDebuggerEditor,
   getFunctionId: getFunctionId,
   getProcedureId: getProcedureId,
   setDebuggerTitle: setDebuggerTitle,
diff --git a/web/pgadmin/tools/debugger/static/js/index.js b/web/pgadmin/tools/debugger/static/js/index.js
new file mode 100644
index 00000000..4499fda4
--- /dev/null
+++ b/web/pgadmin/tools/debugger/static/js/index.js
@@ -0,0 +1,24 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import pgAdmin from 'sources/pgadmin';
+import pgBrowser from 'top/browser/static/js/browser';
+import Debugger from './DebuggerModule';
+// import DirectDebug from './direct';
+
+if (!pgAdmin.Tools) {
+  pgAdmin.Tools = {};
+}
+
+pgAdmin.Tools.Debugger = Debugger.getInstance(pgAdmin, pgBrowser);
+// pgAdmin.Tools.DirectDebug = DirectDebug.getInstance(pgAdmin, pgBrowser);
+
+module.exports = {
+  Debugger: Debugger,
+  // DirectDebug: DirectDebug
+};
\ No newline at end of file
diff --git a/web/pgadmin/tools/debugger/tests/test_debugger_clear_all_breakpoint.py b/web/pgadmin/tools/debugger/tests/test_debugger_clear_all_breakpoint.py
index 3af6c3c2..125dbddf 100644
--- a/web/pgadmin/tools/debugger/tests/test_debugger_clear_all_breakpoint.py
+++ b/web/pgadmin/tools/debugger/tests/test_debugger_clear_all_breakpoint.py
@@ -58,13 +58,13 @@ class DebuggerClearAllBreakpoint(BaseTestGenerator):
 
     def clear_all_breakpoint(self):
         if hasattr(self, 'no_breakpoint') and self.no_breakpoint:
-            breakpoint_data = {"breakpoint_list": ''}
+            breakpoint_data = {"breakpoint_list": None}
         else:
-            breakpoint_data = {"breakpoint_list": 3}
+            breakpoint_data = {"breakpoint_list": '3'}
 
         return self.tester.post(
             self.url + str(self.trans_id),
-            data=breakpoint_data)
+            data=json.dumps(breakpoint_data))
 
     def runTest(self):
         """
diff --git a/web/pgadmin/tools/debugger/tests/test_debugger_set_arguments.py b/web/pgadmin/tools/debugger/tests/test_debugger_set_arguments.py
index 7d51084a..1cd03b55 100644
--- a/web/pgadmin/tools/debugger/tests/test_debugger_set_arguments.py
+++ b/web/pgadmin/tools/debugger/tests/test_debugger_set_arguments.py
@@ -52,11 +52,10 @@ class DebuggerSetArguments(BaseTestGenerator):
             debugger_utils.initialize_target(self, utils)
 
     def set_arguments(self):
-        args = {"data": json.dumps([
+        args = json.dumps([
             {"server_id": self.server_id, "database_id": self.db_id,
              "schema_id": self.schema_id, "function_id": self.func_id,
              "arg_id": 0, "is_null": 0, "is_expression": 0, "use_default": 1}])
-        }
 
         return self.tester.post(
             self.url + str(self.server_id) + '/' + str(self.db_id) + '/' +
diff --git a/web/regression/javascript/debugger/MockDebuggerComponent.jsx b/web/regression/javascript/debugger/MockDebuggerComponent.jsx
new file mode 100644
index 00000000..7216bc64
--- /dev/null
+++ b/web/regression/javascript/debugger/MockDebuggerComponent.jsx
@@ -0,0 +1,23 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+
+import Theme from 'sources/Theme';
+import {DebuggerContext, DebuggerEventsContext} from '../../../pgadmin/tools/debugger/static/js/components/DebuggerComponent';
+
+export default function MockDebuggerComponent({value, eventsvalue, children}) {
+  return (
+    <DebuggerContext.Provider value={value}>
+      <DebuggerEventsContext.Provider value={eventsvalue}>
+        <Theme>
+          {children}
+        </Theme>
+      </DebuggerEventsContext.Provider>
+    </DebuggerContext.Provider>
+  );
+}
+
+MockDebuggerComponent.propTypes = {
+  value: PropTypes.any,
+  eventsvalue: PropTypes.any,
+  children: PropTypes.any
+};
diff --git a/web/regression/javascript/debugger/debugger_spec.js b/web/regression/javascript/debugger/debugger_spec.js
new file mode 100644
index 00000000..f9d383c1
--- /dev/null
+++ b/web/regression/javascript/debugger/debugger_spec.js
@@ -0,0 +1,286 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import $ from 'jquery';
+window.jQuery = window.$ = $;
+import 'wcdocker';
+import React from 'react';
+import jasmineEnzyme from 'jasmine-enzyme';
+import MockAdapter from 'axios-mock-adapter';
+import axios from 'axios/index';
+import url_for from 'sources/url_for';
+import '../helper/enzyme.helper';
+import { createMount } from '@material-ui/core/test-utils';
+import pgAdmin from 'sources/pgadmin';
+
+import { messages } from '../fake_messages';
+import DebuggerComponent from '../../../pgadmin/tools/debugger/static/js/components/DebuggerComponent';
+import FunctionArguments from '../../../pgadmin/tools/debugger/static/js/debugger_ui';
+import Debugger from '../../../pgadmin/tools/debugger/static/js/DebuggerModule';
+import {TreeFake} from '../tree/tree_fake';
+
+
+describe('Debugger Component', () => {
+  let mount;
+  let funcArgs;
+  let debuggerInstance;
+  let nodeInfo;
+  let mountDOM;
+  let tree;
+  let params;
+  let networkMock;
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(() => {
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+    networkMock.restore();
+  });
+
+  afterEach(() => {
+    networkMock.restore();
+  });
+
+  beforeEach(() => {
+    jasmineEnzyme();
+    // Element for mount wcDocker panel
+    mountDOM = $('<div class="dockerContainer">');
+    $(document.body).append(mountDOM);
+
+    $(document.body).append($('<div id="debugger-main-container">'));
+
+    /* messages used by validators */
+    pgAdmin.Browser = pgAdmin.Browser || {};
+    pgAdmin.Browser.messages = pgAdmin.Browser.messages || messages;
+    pgAdmin.Browser.utils = pgAdmin.Browser.utils || {};
+    funcArgs = new FunctionArguments();
+    debuggerInstance = new Debugger(pgAdmin, pgAdmin.Browser);
+    nodeInfo = { parent: {} };
+    pgAdmin.Browser.preferences_cache = [
+      {
+        'id': 115,
+        'cid': 13,
+        'name': 'btn_step_into',
+        'label': 'Accesskey (Step into)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 73,
+            'char': 'i'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      }, {
+        'id': 116,
+        'cid': 13,
+        'name': 'btn_step_over',
+        'label': 'Accesskey (Step over)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 79,
+            'char': 'o'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      },
+      {
+        'id': 113,
+        'cid': 13,
+        'name': 'btn_start',
+        'label': 'Accesskey (Continue/Start)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 67,
+            'char': 'c'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      }, {
+        'id': 114,
+        'cid': 13,
+        'name': 'btn_stop',
+        'label': 'Accesskey (Stop)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 83,
+            'char': 's'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      }, {
+        'id': 117,
+        'cid': 13,
+        'name': 'btn_toggle_breakpoint',
+        'label': 'Accesskey (Toggle breakpoint)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 84,
+            'char': 't'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      }, {
+        'id': 118,
+        'cid': 13,
+        'name': 'btn_clear_breakpoints',
+        'label': 'Accesskey (Clear all breakpoints)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 88,
+            'char': 'x'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      }
+
+    ];
+    // eslint-disable-next-line
+    let docker = new wcDocker(
+      '.dockerContainer', {
+        allowContextMenu: false,
+        allowCollapse: false,
+        loadingClass: 'pg-sp-icon',
+      });
+
+    tree = new TreeFake();
+    pgAdmin.Browser.tree = tree;
+    pgAdmin.Browser.docker = docker;
+
+    params = {
+      transId: 1234,
+      directDebugger: debuggerInstance,
+      funcArgsInstance: funcArgs
+    };
+    networkMock = new MockAdapter(axios);
+  });
+
+  it('DebuggerInit Indirect', () => {
+    params.directDebugger.debug_type = 1;
+    networkMock.onGet(url_for('debugger.start_listener', {'trans_id': params.transId})).reply(200, {'success':1,'errormsg':'','info':'','result':null,'data':{'status':true,'result':2}});
+    networkMock.onGet(url_for('debugger.messages', {'trans_id': params.transId})).reply(200, {'success':1,'errormsg':'','info':'','result':null,'data':{'status':'Success','result':'10'}});
+    networkMock.onGet(url_for('debugger.execute_query', {'trans_id': params.transId, 'query_type': 'get_stack_info'})).reply(200, {'success':1,'errormsg':'','info':'','result':null,'data':{'status':'Success','result':[{'level':0,'targetname':'_test()','func':3138947,'linenumber':9,'args':''}]}});
+    networkMock.onGet(url_for('debugger.poll_result', {'trans_id': params.transId})).reply(200, {'success':0,'errormsg':'','info':'','result':null,'data':{'status':'Success','result':[{'pldbg_wait_for_target':28298}]}});
+    mount(
+      <DebuggerComponent
+        pgAdmin={pgAdmin}
+        panel={document.getElementById('debugger-main-container')}
+        selectedNodeInfo={nodeInfo}
+        layout={''}
+        params={params}
+      >
+      </DebuggerComponent>
+    );
+  });
+});
+
diff --git a/web/regression/javascript/debugger/debugger_tool_bar.js b/web/regression/javascript/debugger/debugger_tool_bar.js
new file mode 100644
index 00000000..1e06b90d
--- /dev/null
+++ b/web/regression/javascript/debugger/debugger_tool_bar.js
@@ -0,0 +1,388 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import $ from 'jquery';
+window.jQuery = window.$ = $;
+import 'wcdocker';
+import React from 'react';
+import jasmineEnzyme from 'jasmine-enzyme';
+import MockAdapter from 'axios-mock-adapter';
+import axios from 'axios/index';
+import url_for from 'sources/url_for';
+import '../helper/enzyme.helper';
+import { createMount } from '@material-ui/core/test-utils';
+import pgAdmin from 'sources/pgadmin';
+
+import { messages } from '../fake_messages';
+import FunctionArguments from '../../../pgadmin/tools/debugger/static/js/debugger_ui';
+import Debugger from '../../../pgadmin/tools/debugger/static/js/DebuggerModule';
+import { TreeFake } from '../tree/tree_fake';
+import MockDebuggerComponent from './MockDebuggerComponent';
+import EventBus from '../../../pgadmin/static/js/helpers/EventBus';
+import { ToolBar } from '../../../pgadmin/tools/debugger/static/js/components/ToolBar';
+
+
+describe('Debugger Toolbar', () => {
+  let mount;
+  let funcArgs;
+  let debuggerInstance;
+  let mountDOM;
+  let tree;
+  let params;
+  let networkMock;
+  let pref;
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(() => {
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+    networkMock.restore();
+  });
+
+  beforeEach(() => {
+    jasmineEnzyme();
+    // Element for mount wcDocker panel
+    mountDOM = $('<div class="dockerContainer">');
+    $(document.body).append(mountDOM);
+
+    $(document.body).append($('<div id="debugger-main-container">'));
+
+    /* messages used by validators */
+    pgAdmin.Browser = pgAdmin.Browser || {};
+    pgAdmin.Browser.messages = pgAdmin.Browser.messages || messages;
+    pgAdmin.Browser.utils = pgAdmin.Browser.utils || {};
+    funcArgs = new FunctionArguments();
+    debuggerInstance = new Debugger(pgAdmin, pgAdmin.Browser);
+    pref = [
+      {
+        'id': 115,
+        'cid': 13,
+        'name': 'btn_step_into',
+        'label': 'Accesskey (Step into)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 73,
+            'char': 'i'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      }, {
+        'id': 116,
+        'cid': 13,
+        'name': 'btn_step_over',
+        'label': 'Accesskey (Step over)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 79,
+            'char': 'o'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      },
+      {
+        'id': 113,
+        'cid': 13,
+        'name': 'btn_start',
+        'label': 'Accesskey (Continue/Start)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 67,
+            'char': 'c'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      }, {
+        'id': 114,
+        'cid': 13,
+        'name': 'btn_stop',
+        'label': 'Accesskey (Stop)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 83,
+            'char': 's'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      }, {
+        'id': 117,
+        'cid': 13,
+        'name': 'btn_toggle_breakpoint',
+        'label': 'Accesskey (Toggle breakpoint)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 84,
+            'char': 't'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      }, {
+        'id': 118,
+        'cid': 13,
+        'name': 'btn_clear_breakpoints',
+        'label': 'Accesskey (Clear all breakpoints)',
+        'type': 'keyboardshortcut',
+        'help_str': null,
+        'control_props': {},
+        'min_val': null,
+        'max_val': null,
+        'options': null,
+        'select': null,
+        'value': {
+          'key': {
+            'key_code': 88,
+            'char': 'x'
+          }
+        },
+        'fields': [
+          {
+            'name': 'key',
+            'type': 'keyCode',
+            'label': 'Key'
+          }
+        ],
+        'disabled': false,
+        'dependents': null,
+        'mid': 83,
+        'module': 'debugger',
+      }
+
+    ];
+
+    pgAdmin.Browser.preferences_cache = pref;
+    // eslint-disable-next-line
+    let docker = new wcDocker(
+      '.dockerContainer', {
+        allowContextMenu: false,
+        allowCollapse: false,
+        loadingClass: 'pg-sp-icon',
+      });
+
+    tree = new TreeFake();
+    pgAdmin.Browser.tree = tree;
+    pgAdmin.Browser.docker = docker;
+
+    params = {
+      transId: 1234,
+      directDebugger: debuggerInstance,
+      funcArgsInstance: funcArgs
+    };
+    networkMock = new MockAdapter(axios);
+  });
+
+  it('Toolbar clearbreakpoints', () => {
+    networkMock.onGet(url_for('debugger.clear_all_breakpoint', { 'trans_id': params.transId })).reply(200, { 'success': 1, 'errormsg': '', 'info': '', 'result': null, 'data': { 'status': true, 'result': 2 } });
+    let ctrl = mount(
+      <MockDebuggerComponent value={{
+        docker: '',
+        api: networkMock,
+        modal: {},
+        params: params,
+        preferences: pgAdmin.Browser.preferences_cache,
+      }}
+      eventsvalue={new EventBus()}>
+        <ToolBar></ToolBar>
+      </MockDebuggerComponent>
+    );
+    ctrl.find('PgIconButton[data-test="clear-breakpoint"]').props().onClick();
+  });
+
+  it('Toolbar Stop Debugger', () => {
+    networkMock.onGet(url_for('debugger.execute_query', { 'trans_id': params.transId, 'query_type': 'abort_target'})).reply(200, {'success':1,'errormsg':'','info':'Debugging aborted successfully.','result':null,'data':{'status':'Success','result':{'columns':[{'name':'pldbg_abort_target','type_code':16,'display_size':null,'internal_size':1,'precision':null,'scale':null,'null_ok':null,'table_oid':null,'table_column':null,'display_name':'pldbg_abort_target'}],'rows':[{'pldbg_abort_target':true}]}}});
+    let ctrl = mount(
+      <MockDebuggerComponent value={{
+        docker: '',
+        api: networkMock,
+        modal: {},
+        params: params,
+        preferences: pgAdmin.Browser.preferences_cache,
+      }}
+      eventsvalue={new EventBus()}>
+        <ToolBar></ToolBar>
+      </MockDebuggerComponent>
+    );
+    ctrl.find('PgIconButton[data-test="stop-debugger"]').props().onClick();
+  });
+
+
+  it('Toolbar Toggle Breakpoint', () => {
+    networkMock.onGet(url_for('debugger.set_breakpoint', { 'trans_id': params.transId, 'line_no': '1', 'set_type': 1})).reply(200, {'success':1,'errormsg':'','info':'','result':null,'data':{'status':true,'result':[{'pldbg_set_breakpoint':true}]}});
+    let ctrl = mount(
+      <MockDebuggerComponent value={{
+        docker: '',
+        api: networkMock,
+        modal: {},
+        params: params,
+        preferences: pgAdmin.Browser.preferences_cache,
+      }}
+      eventsvalue={new EventBus()}>
+        <ToolBar></ToolBar>
+      </MockDebuggerComponent>
+    );
+    ctrl.find('PgIconButton[data-test="toggle-breakpoint"]').props().onClick();
+  });
+
+
+  it('Toolbar StepIn', () => {
+    networkMock.onGet(url_for('debugger.execute_query', { 'trans_id': params.transId, 'query_type': 'step_into'})).reply(200, {'success':1,'errormsg':'','info':'','result':null,'data':{'status':true,'result':1}});
+    let ctrl = mount(
+      <MockDebuggerComponent value={{
+        docker: '',
+        api: networkMock,
+        modal: {},
+        params: params,
+        preferences: pgAdmin.Browser.preferences_cache,
+      }}
+      eventsvalue={new EventBus()}>
+        <ToolBar></ToolBar>
+      </MockDebuggerComponent>
+    );
+    ctrl.find('PgIconButton[data-test="step-in"]').props().onClick();
+  });
+
+  it('Toolbar StepOver', () => {
+    networkMock.onGet(url_for('debugger.execute_query', { 'trans_id': params.transId, 'query_type': 'step_over'})).reply(200, {'success':1,'errormsg':'','info':'','result':null,'data':{'status':true,'result':1}});
+    let ctrl = mount(
+      <MockDebuggerComponent value={{
+        docker: '',
+        api: networkMock,
+        modal: {},
+        params: params,
+        preferences: pgAdmin.Browser.preferences_cache,
+      }}
+      eventsvalue={new EventBus()}>
+        <ToolBar></ToolBar>
+      </MockDebuggerComponent>
+    );
+    ctrl.find('PgIconButton[data-test="step-over"]').props().onClick();
+  });
+
+  it('Toolbar Contiue', () => {
+    networkMock.onGet(url_for('debugger.execute_query', { 'trans_id': params.transId, 'query_type': 'continue'})).reply(200, {'success':1,'errormsg':'','info':'','result':null,'data':{'status':true,'result':2}});
+    let ctrl = mount(
+      <MockDebuggerComponent value={{
+        docker: '',
+        api: networkMock,
+        modal: {},
+        params: params,
+        preferences: pgAdmin.Browser.preferences_cache,
+      }}
+      eventsvalue={new EventBus()}>
+        <ToolBar></ToolBar>
+      </MockDebuggerComponent>
+    );
+    ctrl.find('PgIconButton[data-test="debugger-contiue"]').props().onClick();
+  });
+
+  it('Toolbar Help', () => {
+    networkMock.onGet(url_for('help.static', {'filename': 'debugger.html'})).reply(200, {});
+    let ctrl = mount(
+      <MockDebuggerComponent value={{
+        docker: '',
+        api: networkMock,
+        modal: {},
+        params: params,
+        preferences: pgAdmin.Browser.preferences_cache,
+      }}
+      eventsvalue={new EventBus()}>
+        <ToolBar></ToolBar>
+      </MockDebuggerComponent>
+    );
+    ctrl.find('PgIconButton[data-test="debugger-help"]').props().onClick();
+  });
+});
+
diff --git a/web/regression/javascript/debugger_utils_spec.js b/web/regression/javascript/debugger_utils_spec.js
index 1f8bb62d..196f3a32 100644
--- a/web/regression/javascript/debugger_utils_spec.js
+++ b/web/regression/javascript/debugger_utils_spec.js
@@ -8,44 +8,10 @@
 //////////////////////////////////////////////////////////////////////////
 
 import {
-  setFocusToDebuggerEditor,
   getProcedureId,
+  getFunctionId,
 } from '../../pgadmin/tools/debugger/static/js/debugger_utils';
 
-describe('setFocusToDebuggerEditor', function () {
-  let editor;
-  editor = jasmine.createSpyObj('editor', ['focus']);
-
-  let tab_key = {
-    which: 9,
-    keyCode: 9,
-  };
-
-  let enter_key = {
-    which: 13,
-    keyCode: 13,
-  };
-
-  describe('setFocusToDebuggerEditor', function () {
-    it('returns undefined if no command is passed', function () {
-      expect(setFocusToDebuggerEditor(editor, null)).toEqual(undefined);
-    });
-  });
-
-  describe('setFocusToDebuggerEditor', function () {
-    it('should call focus on editor', function () {
-      setFocusToDebuggerEditor(editor, enter_key);
-      expect(editor.focus).toHaveBeenCalled();
-    });
-  });
-
-  describe('setFocusToDebuggerEditor', function () {
-    it('should not call focus on editor and returns undefined', function () {
-      expect(setFocusToDebuggerEditor(editor, tab_key)).toEqual(undefined);
-    });
-  });
-});
-
 describe('getProcedureId', function () {
   let treeInfroProc = {
     'procedure': {
@@ -83,3 +49,31 @@ describe('getProcedureId', function () {
   });
 });
 
+describe('getFunctionId', function () {
+  let treeInfroFunc = {
+    'function': {
+      '_id': 123,
+    },
+  };
+  let treeInfroInvalidFuncId = {
+    'function': {
+      '_id': null,
+    },
+  };
+
+  let fakeTreeInfro;
+
+  describe('Should return proper object id', function () {
+    it('returns valid function id', function () {
+      expect(getFunctionId(treeInfroFunc)).toEqual(123);
+    });
+
+    it('returns undefined for fake tree info', function () {
+      expect(getFunctionId(fakeTreeInfro)).toEqual(undefined);
+    });
+
+    it('returns undefined for invalid function id', function () {
+      expect(getFunctionId(treeInfroInvalidFuncId)).toEqual(undefined);
+    });
+  });
+});
diff --git a/web/regression/javascript/schema_ui_files/debugger_args.ui.spec.js b/web/regression/javascript/schema_ui_files/debugger_args.ui.spec.js
new file mode 100644
index 00000000..9a67d11a
--- /dev/null
+++ b/web/regression/javascript/schema_ui_files/debugger_args.ui.spec.js
@@ -0,0 +1,49 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import React from 'react';
+import '../helper/enzyme.helper';
+import { createMount } from '@material-ui/core/test-utils';
+import SchemaView from '../../../pgadmin/static/js/SchemaView';
+import {DebuggerArgumentSchema} from '../../../pgadmin/tools/debugger/static/js/components/DebuggerArgs.ui';
+import {genericBeforeEach} from '../genericFunctions';
+
+describe('DebuggerArgs', () => {
+  let mount;
+  let schemaObj = new DebuggerArgumentSchema(
+  );
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(() => {
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(() => {
+    genericBeforeEach();
+  });
+
+  it('create', () => {
+    mount(<SchemaView
+      formType='dialog'
+      schema={schemaObj}
+      viewHelperProps={{
+        mode: 'create',
+      }}
+      onDataChange={() => {/*This is intentional (SonarQube)*/}}
+      showFooter={false}
+      isTabView={false}
+    />);
+  });
+});
+
diff --git a/web/webpack.config.js b/web/webpack.config.js
index 4818f028..533a2682 100644
--- a/web/webpack.config.js
+++ b/web/webpack.config.js
@@ -378,7 +378,7 @@ module.exports = [{
     codemirror: sourceDir + '/bundle/codemirror.js',
     slickgrid: sourceDir + '/bundle/slickgrid.js',
     sqleditor: './pgadmin/tools/sqleditor/static/js/index.js',
-    debugger_direct: './pgadmin/tools/debugger/static/js/direct.js',
+    debugger: './pgadmin/tools/debugger/static/js/index.js',
     schema_diff: './pgadmin/tools/schema_diff/static/js/schema_diff_hook.js',
     erd_tool: './pgadmin/tools/erd/static/js/erd_tool_hook.js',
     psql_tool: './pgadmin/tools/psql/static/js/index.js',
@@ -543,8 +543,7 @@ module.exports = [{
             'pure|pgadmin.tools.maintenance',
             'pure|pgadmin.tools.import_export',
             'pure|pgadmin.tools.import_export_servers',
-            'pure|pgadmin.tools.debugger.controller',
-            'pure|pgadmin.tools.debugger.direct',
+            'pure|pgadmin.tools.debugger',
             'pure|pgadmin.node.pga_job',
             'pure|pgadmin.tools.schema_diff',
             'pure|pgadmin.tools.storage_manager',
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index 39ba3fc3..4d5d13d9 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -275,8 +275,7 @@ var webpackShimConfig = {
     'pgadmin.server.supported_servers': '/browser/server/supported_servers',
     'pgadmin.tables.js': path.join(__dirname, './pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/'),
     'pgadmin.tools.backup': path.join(__dirname, './pgadmin/tools/backup/static/js/backup'),
-    'pgadmin.tools.debugger.controller': path.join(__dirname, './pgadmin/tools/debugger/static/js/debugger'),
-    'pgadmin.tools.debugger.direct': path.join(__dirname, './pgadmin/tools/debugger/static/js/direct'),
+    'pgadmin.tools.debugger': path.join(__dirname, './pgadmin/tools/debugger/static/js/'),
     'pgadmin.tools.debugger.ui': path.join(__dirname, './pgadmin/tools/debugger/static/js/debugger_ui'),
     'pgadmin.tools.debugger.utils': path.join(__dirname, './pgadmin/tools/debugger/static/js/debugger_utils'),
     'pgadmin.tools.grant_wizard': path.join(__dirname, './pgadmin/tools/grant_wizard/static/js/grant_wizard'),
